package com.hzs.system.sys.service;

import java.util.List;
import java.util.Map;
import java.util.Set;

import com.hzs.common.domain.system.sys.SysMenu;
import com.hzs.common.domain.system.sys.vo.RouterVo;

/**
 * 菜单 业务层
 *
 * @author hzs
 */
public interface ISysMenuService {

    /**
     * 根据用户查询系统菜单列表
     *
     * @param menu   菜单信息
     * @param userId 用户ID
     * @return
     */
    List<SysMenu> selectMenuList(SysMenu menu, Long userId);

    /**
     * @description: 导出查询全部菜单
     * @author: zhang jing
     * @date: 2023/7/27 14:00
     * @param: [menu]
     * @return: java.util.List<com.hzs.common.domain.system.sys.SysMenu>
     **/
    List<SysMenu> queryAllMenuAndColumn(SysMenu menu);

    /**
     * 根据用户ID查询按钮权限
     *
     * @param userId 用户ID
     * @return 权限列表
     */
    Set<String> selectButtonPermsByUserId(Long userId);

    /**
     * 根据用户ID查询菜单路由
     *
     * @param userId 用户ID
     * @return 菜单列表
     */
    List<SysMenu> selectMenuRoutersByUserId(Long userId);

    /**
     * 根据供应商ID查询菜单路由
     *
     * @param userId 用户ID
     * @return 菜单列表
     */
    List<SysMenu> selectMenuRoutersBySupplierUserId(Long userId);

    /**
     * 获取用户全部菜单树
     *
     * @param menu
     * @param userId
     * @return
     */
    List<SysMenu> selectAllMenuList(SysMenu menu, Long userId);

    /**
     * 构建前端路由所需要的菜单
     *
     * @param menus 菜单列表
     * @return 路由列表
     */
    List<RouterVo> buildMenus(List<SysMenu> menus);

    /**
     * 构建前端所需要树结构
     *
     * @param menus 菜单列表
     * @return 树结构列表
     */
    List<SysMenu> buildMenuTree(List<SysMenu> menus);

    /**
     * 根据菜单ID查询信息
     *
     * @param menuId 菜单ID
     * @return 菜单信息
     */
    SysMenu selectMenuById(Long menuId);

    /**
     * 是否存在菜单子节点
     *
     * @param menuId 菜单ID
     * @return 结果 true 存在 false 不存在
     */
    boolean hasChildByMenuId(Long menuId);

    /**
     * 新增保存菜单信息
     *
     * @param menu 菜单信息
     * @return 结果
     */
    int insertMenu(SysMenu menu);

    /**
     * 修改保存菜单信息
     *
     * @param menu 菜单信息
     * @return 结果
     */
    int updateMenu(SysMenu menu);

    /**
     * 删除菜单管理信息
     *
     * @param menuId 菜单ID
     * @param userId
     * @return
     */
    int deleteMenuById(Long menuId, Long userId);

    /**
     * 校验菜单名称是否唯一
     *
     * @param menu 菜单信息
     * @return 结果
     */
    String checkMenuNameUnique(SysMenu menu);

    /**
     * 校验菜单权限是否唯一
     *
     * @param perms  权限标识
     * @param menuId 菜单ID
     * @return
     */
    String checkMenuPermsUnique(String perms, Long menuId);

    /**
     * 获取菜单map
     *
     * @return
     */
    Map<Long, SysMenu> getAllMenuMap();

    /**
     * 查询菜单+菜单列
     *
     * @param roleId 角色ID
     * @return
     */
    List<SysMenu> queryMenuAndColumn(Long roleId);

}
